package com.galaxis.manatee.controller;

import com.galaxis.manatee.entity.chuanyun.data.object.ChuanyunOperationInformationDO;
import com.galaxis.manatee.service.ChuanyunService;
import lombok.extern.slf4j.Slf4j;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

@Slf4j
@RestController
@RequestMapping("/equipment")
public class EquipmentController {

    private final ChuanyunService chuanyunService;

    public EquipmentController(ChuanyunService chuanyunService) {
        this.chuanyunService = chuanyunService;
    }

    /**
     * 更新小车信息
     * @param chuanyunOperationInformationDO
     */
    @PostMapping("/updateEquipment")
    public void updateEquipment(@RequestBody ChuanyunOperationInformationDO chuanyunOperationInformationDO){
        chuanyunService.updateOperationInformation(chuanyunOperationInformationDO);
    };
}
