package com.galaxis.manatee.dao;

import com.galaxis.capsule.util.GalaxisRepository;
import com.galaxis.manatee.entity.chuanyun.data.object.ChuanyunProjectChangeDO;
import org.springframework.data.jpa.repository.Query;
import org.springframework.stereotype.Repository;

import java.util.List;

/**
 * Created by IntelliJ IDEA.
 * User: xuj
 * Date: 2020/7/24
 */
@Repository
public interface ChuanyunProjectChangeDao extends GalaxisRepository<ChuanyunProjectChangeDO,String> {
    /**
     * SQL 查询是否存在项目实施变更信息，避免重复提交
     * @param title
     * @return
     */
    @Query(value = "SELECT * FROM CHUANYUN_PROJECT_CHANGE WHERE title = ?1", nativeQuery = true)
    List<ChuanyunProjectChangeDO> findByTitleSQL(String title);

    /**
     * SQL 查询项目实施变更信息
     * @return
     */
    @Query(value = "SELECT t.* FROM CHUANYUN_PROJECT_CHANGE t GROUP BY t.title", nativeQuery = true )
    List<ChuanyunProjectChangeDO> findAllAskForLeave();
}
