package com.galaxis.manatee.dao;

import com.galaxis.capsule.util.GalaxisRepository;
import com.galaxis.manatee.entity.chuanyun.data.object.ChuanyunMemberCostDO;
import com.galaxis.manatee.entity.chuanyun.data.object.ChuanyunProjectCostDO;
import org.springframework.data.jpa.repository.Query;
import org.springframework.data.repository.query.Param;
import org.springframework.stereotype.Repository;
import org.springframework.transaction.annotation.Transactional;

import java.util.List;

/**
 * @author kxuan
 */
@Repository
public interface ChuanyunProjectCostDao extends GalaxisRepository<ChuanyunProjectCostDO,String> {

    /**
     * 获取项目总工时成本
     * @return  项目总工时
     */
    @Query(value="SELECT SUM(chuanyun_self_work_hour.standard_work_hour) AS total_hour," +
            "SUM(chuanyun_self_work_hour.standard_work_hour)/8 AS person_days,chuanyun_self_work_hour.project_id," +
            "chuanyun_self_work_hour.project_type,chuanyun_self_work_hour.`status` ,chuanyun_self_work_hour.object_id \n" +
            "FROM chuanyun_self_work_hour where project_id!='' GROUP BY chuanyun_self_work_hour.project_id,chuanyun_self_work_hour.project_type," +
            "chuanyun_self_work_hour.`status`",
            nativeQuery = true)
    List<ChuanyunProjectCostDO> getProjectCost();



    @Query(value="SELECT SUM(chuanyun_self_work_hour.standard_work_hour) AS total_hour," +
            "SUM(chuanyun_self_work_hour.standard_work_hour)/8 AS person_days,chuanyun_self_work_hour.project_id," +
            "chuanyun_self_work_hour.project_type,chuanyun_self_work_hour.`status` ,chuanyun_self_work_hour.object_id \n" +
            "FROM chuanyun_self_work_hour  WHERE project_id=?1 AND project_type = ?2 AND `status`=2 " +
            "GROUP BY chuanyun_self_work_hour.project_id,chuanyun_self_work_hour.project_type," +
            "chuanyun_self_work_hour.`status`",
            nativeQuery = true)
    ChuanyunProjectCostDO getProcessProjectCost(@Param("projectId")String projectId,@Param("projectType")String projectType);

//
//    @Query(value="SELECT\n" +
//            "\tSUM(\n" +
//            "\t\tchuanyun_self_cost_copy.total_hour\n" +
//            "\t) AS total_hour,\n" +
//            "\t SUM(\n" +
//            "\t\tchuanyun_self_cost_copy.total_hour\n" +
//            "\t) / 8 AS person_days,\n" +
//            "\tchuanyun_self_cost_copy.project_id,\n" +
//            "\tchuanyun_self_cost_copy.project_type,\n" +
//            "\tchuanyun_self_cost_copy.object_id,\n" +
//            "\tchuanyun_self_cost_copy.`status`\n" +
//            "FROM\n" +
//            "\tchuanyun_self_cost_copy\n" +
//            "GROUP BY\n" +
//            "\tchuanyun_self_cost_copy.project_id,\n" +
//            "\tchuanyun_self_cost_copy.project_type,\n" +
//            "\tchuanyun_self_cost_copy.`status`", nativeQuery = true)
//    List<ChuanyunProjectCostDO> getHistoryProjectCost();

    /**
     * 根据项目号获取工时数据
     * @param projectId 项目Id
     * @return  项目工时对象
     */
    ChuanyunProjectCostDO findByProjectIdAndProjectTypeAndStatus(String projectId,String projectType,String status);

    @Transactional
    void deleteByProjectIdAndProjectTypeAndStatus(String projectId,String projectType,String status);
}
