package com.galaxis.manatee.entity.chuanyun.data.object;

import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.databind.annotation.JsonDeserialize;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;
import com.galaxis.manatee.util.ChuanyunLocalDateTimeDeserializer;
import com.galaxis.manatee.util.ChuanyunLocalDateTimeSerializer;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.extern.slf4j.Slf4j;
import org.hibernate.annotations.GenericGenerator;

import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.Id;
import java.time.LocalDateTime;

@Slf4j
@Data
@Entity(name = "CHUANYUN_OPERATION_INFORMATION")
@JsonIgnoreProperties(ignoreUnknown = true)
public class ChuanyunOperationInformationDO {

    /**
     * 表名
     */
    public static final String SCHEMA_CODE ="";

    @Id
    @GeneratedValue(generator = "idGeneratorChuanyunMemberCost")
    @GenericGenerator(name ="idGeneratorChuanyunMemberCost" ,strategy="com.galaxis.capsule.util.GalaxisIdGenerator")
    private Long objectId;

    /**
     * 小车编号
     */
    private String equipmentId;

    /**
     * 设备参数
     */
    private String equipmentParameter;

    /**
     * 设备值
     */
    private String equipmentValue;

    @JsonSerialize(using = ChuanyunLocalDateTimeSerializer.class)
    @JsonDeserialize(using = ChuanyunLocalDateTimeDeserializer.class)
    private LocalDateTime createtime;
}
