package com.galaxis.manatee.entity.chuanyun.data.object;

import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.extern.slf4j.Slf4j;

import javax.persistence.Column;
import javax.persistence.Entity;
import java.math.BigDecimal;

/**
 * @author zcj
 * @version 0.1
 * @date 2020/4/27 1:55 下午
 */
@Slf4j
@Entity(name = "CHUANYUN_REIMBURSEMENT_DETAIL")
@Data
@EqualsAndHashCode(callSuper = true)
@JsonIgnoreProperties(ignoreUnknown = true)
public class ChuanyunReimbursementDetailDO extends BasicSubDO{

    /**
     * 表名
     */
    public static final String SCHEMA_CODE ="D001789F9bd83c8c4057448aa49e5758784dbfc1";

    /**
     * 税率
     */
    @JsonProperty("F0000037")
    private BigDecimal taxRate;

    /**
     * 财务实核金额
     */
    @JsonProperty("F0000048")
    private BigDecimal confirmAmount;

    /**
     * 财务实核税额
     */
    @JsonProperty("F0000049")
    private BigDecimal confirmTax;

    /**
     * 实核未税金额
     */
    private BigDecimal confirmAmountWithoutTax;

    /**
     * 报销科目ID
     */
    @JsonProperty("F0000026")
    private String reimburseSubjectId;

    /**
     * 报销科目
     */
    private String reimburseSubjectName;

    /**
     * 成本费用项目
     * 报销科目档案的U9成本费用项目栏位
     * todo 从reimburseSubjectId获取
     */
    private String reimburseSubjectCode;

    /**
     * 公司编码
     */
    private String reimburseUserCompanyCode;

    /**
     * 报销人成本中心编码
     * TODO 从父表获得
     */
    private String reimburseUserCostCode;

    /**
     * 项目编码
     */
    private String groupProjectCode;
    /**
     * 备注
     */
    @JsonProperty("F0000042")
    @Column(columnDefinition = "TEXT")
    private String content;
}
