package com.galaxis.manatee.entity.chuanyun.data.object;


import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import lombok.Data;
import lombok.extern.slf4j.Slf4j;
import org.hibernate.annotations.GenericGenerator;

import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.Id;
import java.math.BigDecimal;

@Slf4j
@Data
@Entity(name = "CHUANYUN_WEEK_MEMBER_HOUR")
@JsonIgnoreProperties(ignoreUnknown = true)
public class ChuanyunWeekMemberHourDO {

    @Id
    @GeneratedValue(generator = "idGeneratorUser")
    @GenericGenerator(name ="idGeneratorUser" ,strategy="com.galaxis.capsule.util.GalaxisIdGenerator")
    private Long objectId;

    private String userId;

    private String projectType;

    private String projectId;

    /**
     * 流程状态
     */
    private String status;

    /**
     * 年
     */
    private String year;

    /**
     * 周
     */
    private String week;

    private BigDecimal standardWorkHour;

    /**
     * 将一个ChuanyunWeekMemberHourDO对象的属性赋予另外一个ChuanyunWeekMemberHourDO对象，并返回该对象
     * @param chuanyunWeekMemberHourDO  原来的ChuanyunWeekMemberHourDO对象
     * @return  新的对象
     */
    public static ChuanyunWeekMemberHourDO fromChuanyunWeekMemberHourDO(ChuanyunWeekMemberHourDO chuanyunWeekMemberHourDO){
        ChuanyunWeekMemberHourDO newChuanyunWeekMemberHourDO=new ChuanyunWeekMemberHourDO();
        newChuanyunWeekMemberHourDO.setProjectId(chuanyunWeekMemberHourDO.getProjectId());
        newChuanyunWeekMemberHourDO.setProjectType(chuanyunWeekMemberHourDO.getProjectType());
        newChuanyunWeekMemberHourDO.setStandardWorkHour(chuanyunWeekMemberHourDO.getStandardWorkHour());
        newChuanyunWeekMemberHourDO.setStatus(chuanyunWeekMemberHourDO.getStatus());
        newChuanyunWeekMemberHourDO.setUserId(chuanyunWeekMemberHourDO.getUserId());
        newChuanyunWeekMemberHourDO.setYear(chuanyunWeekMemberHourDO.getYear());
        newChuanyunWeekMemberHourDO.setWeek(chuanyunWeekMemberHourDO.getWeek());
        return newChuanyunWeekMemberHourDO;
    }

}
