package com.galaxis.manatee.entity.chuanyun.data.object;


import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.databind.annotation.JsonDeserialize;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;
import com.galaxis.manatee.util.ChuanyunLocalDateTimeDeserializer;
import com.galaxis.manatee.util.ChuanyunLocalDateTimeSerializer;
import lombok.Data;
import lombok.extern.slf4j.Slf4j;

import javax.persistence.Entity;
import javax.persistence.Id;
import java.math.BigDecimal;
import java.time.LocalDateTime;

/**
 * @author kxuan
 */
@Slf4j
@Data
@Entity
@JsonIgnoreProperties(ignoreUnknown = true)
public class ChuanyunWorkHourDO {

    @Id
    private String objectId;

    private String userId;

    /**
     * 项目类型
     */
    private String projectType;

    private String projectId;

    private String departmentName;

    /**
     * 流程状态
     */
    private String status;

    @JsonSerialize(using = ChuanyunLocalDateTimeSerializer.class)
    @JsonDeserialize(using = ChuanyunLocalDateTimeDeserializer.class)
    private LocalDateTime dayLogDate;

    private BigDecimal hoursWorked;
}
