package com.galaxis.manatee.entity.chuanyun.dto;

import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.databind.annotation.JsonDeserialize;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;
import com.galaxis.manatee.util.ChuanyunLocalDateTimeDeserializer;
import com.galaxis.manatee.util.ChuanyunLocalDateTimeSerializer;
import lombok.Data;

import java.math.BigDecimal;
import java.time.LocalDateTime;

/**
 * @author zcj
 * @version 0.1
 * @date 2021/3/6 10:44 上午
 */
@Data
public class ChuanyunSelfCostDTO {

    /**
     * 表名
     */
    public static final String SCHEMA_CODE ="D001789f4833b5cbd0147a4957a7a466e65297a";

    /**
     * 项目ID
     */
    @JsonProperty("F0000003")
    private String projectId;

    /**
     * 项目类型
     */
    @JsonProperty("F0000008")
    private String projectType;

    /**
     * 日志流程状态
     */
    @JsonProperty("F0000009")
    private String status;

    /**
     * 用户ID
     */
    @JsonProperty("F0000002")
    private String userId;

    /**
     * 日期
     */
    @JsonProperty("F0000004")
    @JsonSerialize(using = ChuanyunLocalDateTimeSerializer.class)
    @JsonDeserialize(using = ChuanyunLocalDateTimeDeserializer.class)
    private LocalDateTime dayLogDate;

    /**
     * 工时
     */
    @JsonProperty("F0000005")
    private BigDecimal workHour;

    /**
     * 成本
     */
    @JsonProperty("F0000006")
    private BigDecimal cost;

    /**
     * 月度工时汇总
     */
    @JsonProperty("F0000007")
    private BigDecimal monthWorkHour;

    /**
     * 部门Id
     */
    @JsonProperty("F0000010")
    private String departmentId;
}
