package com.galaxis.manatee.entity.chuanyun.dto;

import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.databind.annotation.JsonDeserialize;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;
import com.galaxis.manatee.util.ChuanyunLocalDateTimeDeserializer;
import com.galaxis.manatee.util.ChuanyunLocalDateTimeSerializer;
import lombok.Data;

import java.math.BigDecimal;
import java.time.LocalDateTime;

/**
 * 氚云日标准工时更新DTO
 * @author zcj
 * @version 0.1
 * @date 2021/3/6 6:18 上午
 */
@Data
public class ChuanyunSelfWorkHourDTO {

    /**
     * 表名
     */
    public static final String SCHEMA_CODE ="D0017899cae010a8a5741b5be13a1fa7f67330d";

    /**
     * 用户ID
     */
    @JsonProperty("F0000002")
    private String userId;

    /**
     * 项目ID
     */
    @JsonProperty("F0000001")
    private String projectId;

    /**
     * 项目类型
     */
    @JsonProperty("F0000005")
    private String projectType;

    /**
     * 部门名称
     */
    @JsonProperty("F0000009")
    private String departmentName;

    /**
     * 流程状态
     */
    @JsonProperty("F0000006")
    private String status;

    /**
     * 日志日期
     */
    @JsonProperty("F0000003")
    @JsonSerialize(using = ChuanyunLocalDateTimeSerializer.class)
    @JsonDeserialize(using = ChuanyunLocalDateTimeDeserializer.class)
    private LocalDateTime dayLogDate;

    @JsonProperty("F0000004")
    private BigDecimal standardWorkHour;

    /**
     * 部门Id
     */
    @JsonProperty("F0000007")
    private String departmentId;

    /**
     * 用户名称
     */
    @JsonProperty("F0000008")
    private String userName;

    /**
     * 所属BG
     */
    @JsonProperty("F0000010")
    private String bg;
}
