package com.galaxis.manatee.service;

import com.galaxis.manatee.entity.chuanyun.data.object.ChuanyunCostCollectionDO;
import com.galaxis.manatee.entity.chuanyun.data.object.ChuanyunEquipmentDO;
import com.galaxis.manatee.entity.chuanyun.data.object.ChuanyunOperationInformationDO;
import com.galaxis.manatee.entity.chuanyun.data.object.ChuanyunProductDO;
import com.galaxis.manatee.entity.chuanyun.dto.ChuanyunOperationInformationDTO;
import org.springframework.scheduling.annotation.Async;

import java.util.List;

/**
 * 氚云服务调用
 */
public interface ChuanyunService {

    /**
     * 更新项目组成员
     */
    void updateProjectMember();

    /**
     * 获取成本集合
     * @return  成本集合
     */
    List<ChuanyunCostCollectionDO> getAllCostCollection();

    /**
     * 根据表单编号更新所属部门信息
     * @param code  表单编号
     */
    void updateChuanyunDept(String code);


    /**
     * 设备配置信息导入
     */
    void importEquipment(List<ChuanyunEquipmentDO> list);

    /**
     * 更新项目中受益部门名称
     */
    void updateU9Department();

    /**
     * 更新小车信息
     */
    void updateOperationInformation(ChuanyunOperationInformationDO chuanyunOperationInformationDO);

    void importProduct(List<ChuanyunProductDO> list);

}
