package com.galaxis.manatee.service;

import com.galaxis.manatee.dao.ChuanyunUserCompanyDao;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Service;

import java.time.Instant;

/**
 * @author zcj
 * @version 0.1
 * @date 2021/3/11 3:30 上午
 */
@Slf4j
@Service
public class LogService {

    private final ChuanyunUserCompanyDao chuanyunUserCompanyDao;
    private final LogStandardService logStandardService;
    private final LogUpdateService logUpdateService;

    public LogService(ChuanyunUserCompanyDao chuanyunUserCompanyDao, LogStandardService logStandardService, LogUpdateService logUpdateService) {
        this.chuanyunUserCompanyDao = chuanyunUserCompanyDao;
        this.logStandardService = logStandardService;
        this.logUpdateService = logUpdateService;
    }

    /**
     * 标准化所有周工时信息
     */
    public void standardAllWeekMemberHour(){
        long start= Instant.now().getEpochSecond();
        chuanyunUserCompanyDao.findAll().forEach(chuanyunUserCompanyDO -> logStandardService.standardWeekMemberHourByUserId(chuanyunUserCompanyDO.getUserId()));
        log.info("标准化所有周工时耗时"+(Instant.now().getEpochSecond()-start)+"秒");
    }

    /**
     * 标准化所有月工时
     */
    public void standardAllSelfCost(){
        long start=Instant.now().getEpochSecond();
        chuanyunUserCompanyDao.findAll().forEach(chuanyunUserCompanyDO -> logStandardService.standardSelfCostByUserId(chuanyunUserCompanyDO.getUserId()));
        log.info("标准化所有月工时耗时"+(Instant.now().getEpochSecond()-start)+"秒");
    }

    /**
     * 更新所有日工时
     */
    public void updateAllChuanyunSelfWorkHour() {
        long startTime = Instant.now().getEpochSecond();
        chuanyunUserCompanyDao.findAll().forEach(chuanyunUserCompanyDO -> logUpdateService.updateChuanyunSelfWorkHourListByUserId(chuanyunUserCompanyDO.getUserId()));
        log.info("更新所有每日工时花费" + (Instant.now().getEpochSecond() - startTime) + "秒");
    }

    /**
     * 更新所有周工时
     */
    public void updateAllChuanyunWeekMemberHour() {
        long startTime = Instant.now().getEpochSecond();
        chuanyunUserCompanyDao.findAll().forEach(chuanyunUserCompanyDO -> logUpdateService.updateChuanyunWeekMemberHourListByUserId(chuanyunUserCompanyDO.getUserId()));
        log.info("更新所有每周工时花费" + (Instant.now().getEpochSecond() - startTime) + "秒");
    }

    /**
     * 更新所有月工时
     */
    public void updateAllChuanyunSelfCost() {
        long startTime = Instant.now().getEpochSecond();
        chuanyunUserCompanyDao.findAll().forEach(chuanyunUserCompanyDO -> logUpdateService.updateChuanyunSelfCostListByUserId(chuanyunUserCompanyDO.getUserId()));
        log.info("更新所有每月工时花费" + (Instant.now().getEpochSecond() - startTime) + "秒");
    }
}
